precision mediump float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;

uniform sampler2D uLastTexture;
varying vec2 vLastTextureCoord;

float calculate(float last,float overlay){

    float result;

    if(overlay<=0.5){

        result=1.0-(1.0-last)/(2.0*overlay);
    }

    if(overlay>0.5){

        result= last/(2.0*(1.0-overlay));

    }
    return result;
}



void main() {

   vec4 overlayColor=texture2D(uTexture,vTextureCoord);

   vec4 lastColor=texture2D(uLastTexture,vLastTextureCoord);

   gl_FragColor=vec4(
                    calculate(lastColor.r,overlayColor.r),
                    calculate(lastColor.g,overlayColor.g),
                    calculate(lastColor.b,overlayColor.b),1.0);
}
