precision highp float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;
uniform sampler2D uTexture2;

uniform mat4 uColorMatrix;
uniform mat3 uGlobalTexCoordMatrix;

void main(){

    vec3 globalTextureCoordinate = vec3(vTextureCoord.xy,1.0)*uGlobalTexCoordMatrix;
	vec4 color = uColorMatrix*texture2D(uTexture, vTextureCoord.xy);
	float d = 1.0 - length(globalTextureCoordinate.xy - vec2(0.5,0.5))*1.4142;
	float r,g,b;
	r = texture2D(uTexture2, vec2(color.r,d)).r;
	g = texture2D(uTexture2, vec2(color.g,d)).g;
	b = texture2D(uTexture2, vec2(color.b,d)).b;
	gl_FragColor = vec4(r,g,b,1.0);

}