precision highp float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;
uniform sampler2D uTexture2;

uniform float width;
uniform float height;

const float size=8.0;
const float threshold=0.2;
const float alpha = 0.6;
//自然清新
void main() {
	const int N = 2;
	vec2 textual = vec2(size / width, size / height);
	vec3 color = texture2D(uTexture, vTextureCoord).rgb;

	if (threshold > 0.01) {
		vec3 tmp;
		vec3 sumColor = vec3(0.0);
		float sum = 0.0;
		float dis;
		for (int i = -N; i <= N; i++) {
			for (int j = -N; j <= N; j++) {
				tmp = texture2D(
				        uTexture,
						vTextureCoord+ vec2(textual.x * float(i),textual.y * float(j))
						).rgb;

				dis = distance(tmp, color);

				if (dis < threshold) {
					sumColor += tmp * (threshold - dis);
					sum += (threshold - dis);
				}
			}
		}
		color = mix(color, sumColor / sum, alpha);
	}

    color.r = texture2D(uTexture2, vec2(color.r, 0.5)).r;
    color.g = texture2D(uTexture2, vec2(color.g, 0.5)).g;
    color.b = texture2D(uTexture2, vec2(color.b, 0.5)).b;
    gl_FragColor = vec4(color, 1.0);
}