precision highp float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;
uniform sampler2D uTexture2;
 
 void main()
 {
     float H;
     float S;
     float V;
     vec4 color = texture2D(uTexture, vTextureCoord.xy);
     
     float minRGB;
     float maxRGB;

     float r = color.r;
     float g = color.g;
     float b = color.b;
     float step = 0.001953;//1.0 / 512.0;
     
     float y_curve = 0.507812;//130.0/256.0;
     
     int i;
     float f;
     float p;
     float q;
     float t;
     
     //curve adjust
     r = texture2D(uTexture2, vec2(r*0.5, y_curve)).r;
     g = texture2D(uTexture2, vec2(g*0.5, y_curve)).g;
     b = texture2D(uTexture2, vec2(b*0.5, y_curve)).b;
    
     /////rbg to hsv , identical to photoshop cs5
     minRGB = min(r, min(g,b));
     maxRGB = max(r, max(g,b));
     float diff = maxRGB - minRGB;
     float y_h1 = 0.058594*2.0;//30.0 / 256.0;
     float y_h2 = 0.15625*2.0;//80.0 / 256.0;
     // Black-gray-white
     {
         float tmp1;
         float tmp2;
         if(r == minRGB)
         {
             tmp1 = 3.0;
             tmp2 = g-b;
         }
         else if(b == minRGB)
         {
             tmp1 = 1.0;
             tmp2 = r-g;
         }
         else
         {
             tmp1 = 5.0;
             tmp2 = b-r;
         }

         H = (tmp1 - tmp2/diff) * 60.0;
         S = (diff/maxRGB) * 100.0;
         V = (maxRGB) * 100.0;
         
         //////need an error gap
         H = min(H, 350.0);
         S = min(S, 95.0);
         V = min(V, 95.0);
         
         H = texture2D(uTexture2, vec2(H*step, y_h1)).r + texture2D(uTexture2, vec2(H*step, y_h2)).r;
         S = texture2D(uTexture2, vec2(S*step, y_h1)).g;
         V = texture2D(uTexture2, vec2(V*step, y_h1)).b;
        
         H *= 4.25;//255.0 / 60.0;// sector 0 to 5
         S *= 2.55;//255.0 / 100.0;
         V *= 2.55;//255.0 / 100.0;
         
         {
             i = int(H);
             f = H - float(i); // factorial part of h
             
             float VS = V*S;
             float VSf = VS*f;
             p = V - VS;
             q = V - VSf;
             t = p + VSf;
             
             if(i == 0)
             {
                 r = V;
                 g = t;
                 b = p;
             }
             else if(i == 1)
             {
                 r = q;
                 g = V;
                 b = p;
             }
             else if(i == 2)
             {
                 r = p;
                 g = V;
                 b = t;
             }
             else if(i == 3)
             {
                 r = p;
                 g = q;
                 b = V;
             }
             else if(i == 4)
             {
                 r = t;
                 g = p;
                 b = V;
             }
             else
             {
                 // case 5:
                 r = V;
                 g = p;
                 b = q;
             }
         }
     }
     
     gl_FragColor = vec4(r, g, b,1.0);
     
}